#!/usr/local/bin/wish8.0
# Tcltexed | Version 1.8 | 27. Aug. 1998 | Martin Strauss
set Tcltexed_Version 1.8 
# A plaintexteditor for LaTeX based on scriptlanguage tcl/tk (8.x) 
#
# Copyright (C) 1998  Martin Strauss
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
###############################################################
# Begin of Tcltexed
 set basepath /f/fs-phy/mys/tcltexed-1.8
 set befehlemenupath $basepath/befehlemenu
 set txtpath $basepath/txt
 set hlppath $basepath/hlp
 set gifpath $basepath/gif
 set bhtpath $basepath/bht
 set etcpath $basepath/etc
 switch $tcl_platform(platform) unix {
  set inifile $env(HOME)/.tcltexed
 } windows {
  switch $tcl_platform(os) "Windows 95" {
   set inifile $etcpath/tcltexed.ini
  } "Windows NT" {
   set inifile $env(USERPROFILE)/tcltexed.ini
  }
 }
 #############################
 # externe Befehle
 switch $tcl_platform(platform) unix {
  # unix und linux Programme
  set latex_exec "latex" 
  set xdvi_exec "xdvi"
  set dvips_exec "dvips"
  set ghostview_exec "ghostview"
 } windows {
  set latex_exec  "latex"
  set xdvi_exec "yap"
  set dvips_exec "dvips"
  set ghostview_exec "C:/gstools/gsview/gsview32"
 } default {exit}
 ##########################################################################
 ####### There is no point to "repair" anything beyond this line ##########
 ##########################################################################
 # Liste aller Befehle mit Klammern wie \frac{ }
 set LISTEK1 [list hat breve grave bar dot check acute tilde vec ddot\
     widetide widehat stackrel overbrace underbrace overline underline sqrt]
 # Liste alle Mathematik Fenster
 set MathematikListe [list Umgebung Grundbefehle Akzente Alphabet Funktionen "binaere Operatoren" Pfeile Vergleichssymbole "sonstige Symbole"]  
 # Liste aller "Allgemein" Fenster
 set AllgemeinListe [list Gliederung Schrift Document]  
 # Bytezahl die maximal der Undo-Funktion pro Fenster zur Verfuehgung steht
 set max_undo 200 
 # Bekannte Packete
 set PLISTE [list latex latex picture picture amsmath amsmath amssymb amssymb amsfonts amsfonts amscd amscd amsthm amsthm epsf epsf graphics "graphics/x"]

 ##########################################################################
 ##########################################################################
 # You won't believe it what happens if you ... so leave it the way it is #
 ##########################################################################
 # Testwindow
 # toplevel .test
 # label .test.t1 
 #  label .test.t2 
 #pack .test.t1 .test.t2

 # Editor
 set EDITORNUMMER 0
 # Focus
 set FocusEditorFlag 0
 set FocusEditor ""
 # Filenamen
 set FilenameArray(scratch) "scratch"
 set ModifiedArray(scratch) 0
 set UndoArray(scratch) ""
 # Block
 set BlockBeginFlag 0
 set BlockEndFlag 0
 set BlockEditor ""
 # Projekt
 set MasterFlag 0
 set Master ""
 set Masterfile ""
 set MasterBildSlaveOn [image create photo  -file "$gifpath/slaveon.gif"] 
 set MasterBildSlaveOff [image create photo  -file "$gifpath/slaveoff.gif"] 
 set MasterBildMasterOn [image create photo  -file "$gifpath/masteron.gif"] 
 set MasterBildMasterOff [image create photo  -file "$gifpath/masteroff.gif"] 
 # Search
 set wsearch_gb 1
 # Klammern automatische
 set KlammerFlag 1
 # My Own
 set myown_max 10
 ###########################################################################
 # tag Farben
 # Syntax Highlightning
 set SyntaxColorBlue Blue
 set SyntaxColorRed Red
 set SyntaxColorGreen "#007300"
 # LaTeX-Befehlsergaenzung
 set ErgaenzungGray Gray
 # Block
 set BlockColor "#e0e0e0"
 ############################################################################
proc I {name befehl hlp txt back} {
 global I_befehl
 global I_hlp
 global I_txt
 global I_back
 global I_state
 global I_flag
 switch $I_flag 2 {
  set I_befehl($name) $befehl
  set I_hlp($name) $hlp
  set I_txt($name) $txt
  set I_back($name) $back
 } 0 {
  unset I_state($name) 
 } 1 {
  set I_state($name) 1
 }
}
 ###############################################################################
 # virtuelle events
 event add <<Modified>> <Return> <Control-i> <Delete> <BackSpace> <Control-slash> <Control-backslash> <Insert> <Control-d> <Control-k><c> <Control-k><m> <Control-k><y> <Control-o> <Meta-d> <Meta-BackSpace> <Meta-Delete> <Control-h> <Button-2>

 event add <<Help>> <F1> <Control-k><h> 
 event add <<HelpHelp>> <Control-F1>

 event add <<BeginFlag>> <Control-KeyPress> <Meta-KeyPress> <Alt-KeyPress> <Button> <Return> <Delete> <BackSpace> <Insert> <Tab> <Shift-Tab> <Control-Tab> <Control-Shift-Tab> <Control-i> <Select> <Control-Shift-space> <Shift-Select> <Control-slash> <Control-backslash> <Control-space>

 event add <<proc_undo>> <Up> <Left> <Right> <Down> <Shift-Up> <Shift-Left> <Shift-Right> <Shift-Down> <Control-Up> <Control-Left> <Control-Right> <Control-Down> <Shift-Control-Up> <Shift-Control-Left> <Shift-Control-Right> <Shift-Control-Down> <Prior> <Shift-Prior> <Next> <Shift-Next> <Control-Prior> <Control-Next> <Home> <Shift-Home> <End> <Shift-End> <Control-Home> <Control-Shift-Home>  <Control-End>  <Control-Shift-End>  

 event add <<Position>> <Button> <KeyPress>
 ##############################################################################
 # Umdefinition des Defaultverhaltens fuer Text-variablen
 bind Text <Control-k> {}
 # Block Anfang
 bind Text <Control-k><b> {
  set BlockBeginFlag 1 
  %W mark set BlockBegin insert 
  if {[string compare %W $BlockEditor] == 0} then {
   if $BlockEndFlag then { 
    %W tag remove BlockTag 1.0 end
    %W tag add BlockTag BlockBegin BlockEnd
  }} else { 
   if { $BlockBeginFlag && $BlockEndFlag} then {
    $BlockEditor tag remove BlockTag 1.0 end
   } 
   set BlockEndFlag 0 
   set BlockEditor %W 
  }
 }
 # Block Ende
 bind Text <Control-k><k> {
  set BlockEndFlag 1 
  %W mark set BlockEnd insert
  %W mark gravity BlockEnd left
  if { [string compare %W $BlockEditor] == 0} then {
   if $BlockBeginFlag then {
    %W tag remove BlockTag 1.0 end
    %W tag add BlockTag BlockBegin BlockEnd
  }} else { 
   if { $BlockBeginFlag && $BlockEndFlag} then {
    $Blockeditor tag remove BlockTag 1.0 end 
   }
   set BlockBeginFlag 0 
   set BlockEditor %W 
  }
 }
 # Block kopieren
 bind Text <Control-k><c> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   switch_Undo %W UndoBegin
   %W insert insert [$BlockEditor get BlockBegin BlockEnd]
   switch_Undo %W UndoEnd
  }
 }
 # Block verschieben
 bind Text <Control-k><m> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   switch_Undo %W UndoBegin
   %W insert insert [$BlockEditor get BlockBegin BlockEnd]
   switch_Undo %W UndoEnd
   switch_undo $BlockEditor Block
   if {[string compare %W $BlockEditor] == 0} then {
    UndoMul %W 2
   }
   $BlockEditor delete BlockBegin BlockEnd
  }
 }
 bind Text <Control-k><v> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   switch_Undo %W UndoBegin
   %W insert insert [$BlockEditor get BlockBegin BlockEnd]
   switch_Undo %W UndoEnd
   switch_undo $BlockEditor Block
   if {[string compare %W $BlockEditor] == 0} then {
    UndoMul %W 2
   }
   $BlockEditor delete BlockBegin BlockEnd
  }
 }
 # Block loeschen
 bind Text <Control-k><y> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   switch_undo $BlockEditor Block
   $BlockEditor delete BlockBegin BlockEnd
  }
 }
 # Block auskommentieren
proc AusKomm {E A B} {
 set i [lindex "[split [$E index $A] .]" 0]
 set i_max [lindex "[split [$E index $B] .]" 0]
 incr i_max
 while {$i < $i_max} {
  if [expr [string compare [$E get "$i.0 linestart" "$i.0 linestart + 1 chars"] "%"] != 0] {
   $E insert "$i.0 linestart" "%"
  }
  incr i
 }
}
 # Block auskommentieren rueckgaengig
proc AusKommRueck {E A B} {
 set i [lindex "[split [$E index $A] .]" 0]
 set i_max [lindex "[split [$E index $B] .]" 0]
 incr i_max
 while {$i < $i_max} {
  if [expr [string compare [$E get "$i.0 linestart" "$i.0 linestart + 1 chars"] "%"] == 0] {
   $E delete "$i.0 linestart" "$i.0 linestart + 1 chars"
  }
  incr i
 }
}

 bind Text <Control-k><Shift-5> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   AusKomm %W BlockBegin BlockEnd
  }
 }
 bind Text <Control-k><space> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   AusKommRueck %W BlockBegin BlockEnd
  }
 }
 # Block in Clipboard kopieren
 bind Text <Control-k><g> {
  if { $BlockBeginFlag && $BlockEndFlag} then {
   clipboard clear -displayof %W
   catch {clipboard append -displayof %W [$BlockEditor get BlockBegin BlockEnd]}
  }
 }
 # aus Clipboard kopieren
 bind Text <Control-k><p> {
  switch_Undo %W UndoBegin
  tk_textPaste %W
  switch_Undo %W UndoEnd
 }
  bind Text <Control-k><h> {break}

bind Text <Insert> {
 switch_Undo %W UndoBeginSel
 catch {tkTextInsert %W [selection get -displayof %W]}
 switch_Undo %W UndoEnd
}

 # Block eliminieren
 bind Text <Destroy> {
  set BlockBeginFlag 0
  set BlockEndFlag 0
  if {[lsearch [array names ModifiedArray] %W] != -1} {
   unset ModifiedArray(%W)
  }
  if {[lsearch [array names UndoArray] %W] != -1} {
   unset UndoArray(%W)
  }
  if {[lsearch [array names FilenameArray] %W] != -1} {
   unset FilenameArray(%W)
  }
 }
 # Zeile aus Text loeschen
 bind Text <Control-y> {
  switch_undo %W Zeile
  %W delete "insert linestar" "insert lineend + 1 chars" 
 }
 # Was passiert wenn man ein Fenster vernichtet
 bind Toplevel <Destroy> {
  # Fenster war Master dann Master loeschen
  if $MasterFlag then {if {[string compare $Master %W] == 0} then {set MasterFlag 0}}
  if $FocusEditorFlag then { if {[string compare $FocusEditor %W] == 0} then {set FocusEditorFlag 0}}
 }
 bind Text <KeyPress> {
  if $erg_flag(%W) then {
   if { [%W get insert "insert + 1 chars"] == "%A"} then {
    %W mark set insert "insert + 1 chars"
    continue
   } else {
    erg_proc %W
   }
  }
  switch_Undo %W UndoBeginSel
  tkTextInsert %W %A
  switch_Undo %W UndoEnd

  if [string length %A] then { 
   event generate %W <<ERG>> 
   event generate %W <<Modified>>
   if $KlammerFlag then {
   if {[string compare "%K" "KP_Subtract"] != 0} then {
   if {[string compare "%K" "minus"] != 0} then {
    switch "%A" "(" {
     tkTextInsert %W ")"
     switch_Undo %W UndoEnd
     tkTextSetCursor %W insert-1c
    } "\{" {
     tkTextInsert %W "\}"
     switch_Undo %W UndoEnd
     tkTextSetCursor %W insert-1c
    } "\[" {
     tkTextInsert %W "\]"
     switch_Undo %W UndoEnd
     tkTextSetCursor %W insert-1c
    } "$" {
     tkTextInsert %W "$"
     switch_Undo %W UndoEnd
     tkTextSetCursor %W insert-1c
    }
   }}}
   if $BeginRealy(%W) then {
    %W insert BeginMark %A
    switch_Undo %W BeginMark
   }
   set BeginRealy(%W) $BeginFlag(%W)
  }

 }
 ###############################################################################
 # Default Color
 switch $tcl_platform(platform) unix {
proc Cmenu {E} {
  $E configure -activebackground "#ececec" -activeforeground Black -background "#d9d9d9" -foreground Black -selectcolor White
 }
proc Cbutton {E} {
  $E configure -activebackground "#ececec" -activeforeground Black -disabledforeground "#a3a3a3" -background "#d9d9d9" -foreground Black -highlightbackground "#d9d9d9" -highlightcolor Black
 }
proc Cscrollbar {E} {
  $E configure -activebackground "#ececec"   -background "#d9d9d9" -highlightbackground "#d9d9d9" -highlightcolor Black
 }
proc Ctext {E} {
  $E configure  -background white -foreground Black -highlightbackground "#d9d9d9" -highlightcolor Black
 }
proc Cframe {E} {
  $E configure  -background "#d9d9d9" -highlightbackground "#d9d9d9" -highlightcolor Black
 }
 } windows {
proc Cmenu {E} {
#  $E configure -activebackground "#ececec" -activeforeground Black -background "#c0c0c0" -foreground Black -selectcolor White
 }
proc Cbutton {E} {
  $E configure -activebackground "#ececec" -activeforeground Black -disabledforeground "#a3a3a3" -background "#c0c0c0" -foreground Black -highlightbackground "#d9d9d9" -highlightcolor Black
 }
proc Cscrollbar {E} {
  $E configure -activebackground "#ececec"   -background "#c0c0c0" -highlightbackground "#d9d9d9" -highlightcolor Black
 }
proc Ctext {E} {
  $E configure  -background white -foreground Black -highlightbackground "#d9d9d9" -highlightcolor Black
 }
proc Cframe {E} {
  $E configure  -background "#c0c0c0" -highlightbackground "#d9d9d9" -highlightcolor Black
 }
 }
 ###############################################################################
 # Hauptfenster
 Cframe .
 frame .mb
 Cframe .mb
 menubutton .mb.button1 -text "File" -relief raised -menu .mb.button1.m
 menubutton .mb.button2 -text "Edit" -relief raised -menu .mb.button2.m
 menubutton .mb.button6 -text "Options" -relief raised -menu .mb.button6.m
 menubutton .mb.button3 -text "Mathematik" -relief raised -menu .mb.button3.m
 menubutton .mb.button4 -text "Allgemein" -relief raised -menu .mb.button4.m
 menubutton .mb.button5 -text "Help" -relief raised -menu .mb.button5.m
 Cbutton .mb.button1
 Cbutton .mb.button2
 Cbutton .mb.button3
 Cbutton .mb.button4
 Cbutton .mb.button5
 Cbutton .mb.button6

 pack .mb.button1 .mb.button2 .mb.button6 .mb.button3 .mb.button4 .mb.button5 -side left  -padx 2m -fill x -expand yes

 menu .mb.button1.m
 Cmenu .mb.button1.m
 menu .mb.button2.m
 Cmenu .mb.button2.m
 menu .mb.button3.m
 Cmenu .mb.button3.m
 menu .mb.button4.m
 Cmenu .mb.button4.m
 menu .mb.button5.m
 Cmenu .mb.button5.m
 menu .mb.button6.m
 Cmenu .mb.button6.m

 # Neues EditorFenster  
 .mb.button1.m add command -label "New..." -command {NewFile}
 .mb.button1.m add command -label "Load ..." -command {LoadFile}
 .mb.button1.m add command -label "Append..." -command {
  if $FocusEditorFlag then {AppendFile "$FocusEditor"}
 }
 .mb.button1.m add command -label "Save" -command {
  if $FocusEditorFlag then {SaveFile $FocusEditor}
 }
 .mb.button1.m add command -label "Save As..." -command {
  if $FocusEditorFlag then {SaveAsFile "$FocusEditor"}
 }
 .mb.button1.m add command -label "Quit" -command {ALLQUIT}

 .mb.button2.m add command -label "Clear" -command {
  if $FocusEditorFlag then {
   if {[winfo exists .wclear] == 0} then {
    set sp [tk_dialog $E.wclear Clear "Alles Lschen ?" {} 1 Clear Cancel]
    switch $sp 0 {
     $FocusEditor.te.edit1 delete 1.0 end
    }
 }}}
 .mb.button2.m add command -label "Search c-f" -command {InitSearch}
 .mb.button2.m add command -label "My Own" -command {InitMyOwn}
 .mb.button5.m add command -label "Tcltexed" -command {InitTcltexed}
 .mb.button5.m add command -label "LaTeX Befehle" -command {InitListen}
 .mb.button6.m add checkbutton -variable KlammerFlag -label "AutoKlammerZu"
 menu .mb.button6.m.m
 foreach {i n} $PLISTE {
  set I_flag 2
  source $bhtpath/$i.bht
  .mb.button6.m.m add checkbutton -variable Package($i) -label $n -command "set I_flag \$Package($i)\nsource $bhtpath/$i.bht"
 }
 .mb.button6.m add cascade -label "Packages/etc" -menu .mb.button6.m.m
 .mb.button6.m add command -label "Save Options" -command {SaveOptions}

 wm resizable . 0 0
 wm protocol . WM_DELETE_WINDOW {ALLQUIT}
 proc ALLQUIT {} {
  global ModifiedArray
  global FilenameArray
  set Flag 1 
  set ID [array startsearch ModifiedArray] 
  while {[array anymore ModifiedArray $ID] && $Flag} {
   if $ModifiedArray([array nextelement ModifiedArray $ID]) then {
    set Flag 0
   }
  }
  array donesearch ModifiedArray $ID
  if {$Flag == 0} then {
  set sp [tk_dialog .allquit Quit "Wirklich beenden ?" {} 0 "Save all" "Save some" Quit Cancel]
   switch $sp 0 {
    set ID [array startsearch ModifiedArray] 
    while {[array anymore ModifiedArray $ID]} {
     set E [array nextelement ModifiedArray $ID]
     if $ModifiedArray($E) then {
      set ed [string range $E 0 [expr [string length $E] - 10]]
      focus $ed  
      SaveFile $ed
    }} 
    set Flag 1 
    set ID [array startsearch ModifiedArray] 
    while {[array anymore ModifiedArray $ID] && $Flag} {
     if $ModifiedArray([array nextelement ModifiedArray $ID]) then {
      set Flag 0
     }
    }
    if $Flag then {destroy .}
   } 1 {
    set Flag 1
    set ID [array startsearch ModifiedArray] 
    while {[array anymore ModifiedArray $ID] && $Flag} {
     set E [array nextelement ModifiedArray $ID]
     if $ModifiedArray($E) then {
      set ed [string range $E 0 [expr [string length $E] - 10]]
      focus $ed  
      set ksp [tk_dialog .some "Save some" "Save $FilenameArray($ed)" {} 0 Save Next Cancel]
      switch $ksp 0 {
       SaveFile $ed
      } 2 {
       set Flag 0
      }
    }} 
    set Flag 1 
    set ID [array startsearch ModifiedArray] 
    while {[array anymore ModifiedArray $ID] && $Flag} {
     if $ModifiedArray([array nextelement ModifiedArray $ID]) then {
      set Flag 0
     }
    }
    if $Flag then {destroy .}
   } 2 {destroy .}
  } else {destroy .}
 }
######################################################################################
proc makeWindow {NAME S} {
 global befehlemenupath
 global packstring
 if {[winfo exists $NAME] == 0} then {
  set NAME $NAME
  toplevel $NAME
  Cframe $NAME 
  set packstring ""
  source "$befehlemenupath/$S"
  button $NAME.q -text "Quit" -command "destroy $NAME"
  Cbutton $NAME.q
  pack  $NAME.q
  bind $NAME <Control-c> {
   destroy %W
  }
  bind $NAME <<Help>> "set ksp \[winfo containing -displayof $NAME \[winfo pointerx $NAME\] \[winfo pointery $NAME\]\]\n if {\$ksp != \"\"} then {event generate \$ksp <<HelpHelp>>}"

  bind $NAME <Button-3> "set ksp \[winfo containing -displayof $NAME \[winfo pointerx $NAME\] \[winfo pointery $NAME\]\]\n if {\$ksp != \"\"} then {event generate \$ksp <<HelpHelp>>}"

  wm resizable $NAME 0 0
 }
}

 set ii 0
 foreach i $MathematikListe {
  incr ii
  set NAME ".befehlemenumathe$ii"
  .mb.button3.m add command -label $i -command "makeWindow $NAME \"Mathematik/$i\""
 }
 set ii 0
 foreach i $AllgemeinListe {
  incr ii
  set NAME ".befehlemenuallg$ii"
  .mb.button4.m add command -label $i -command "makeWindow $NAME \"Allgemein/$i\""
  }
 pack .mb   -pady 2m -fill x
#########################################################################################
proc Master {E} { 
 global MasterFlag
 global Master
 global MasterBildMasterOn
 global MasterBildSlaveOn
 global MasterBildMasterOff
 global MasterBildSlaveOff
 if $MasterFlag then {
  if [string compare $Master $E] then {
   $Master.todo.master configure -image $MasterBildSlaveOff
   set Master $E
   $Master.todo.master configure -image $MasterBildMasterOn
  } else {
   set MasterFlag 0
   $Master.todo.master configure -image $MasterBildSlaveOn
 }} else {
  set MasterFlag 1
  set Master $E 
  $Master.todo.master configure -image $MasterBildMasterOn
 }
}
proc MasterFocus {NEW OLD} {
 global MasterFlag
 global Master
 global MasterBildMasterOn
 global MasterBildSlaveOn
 global MasterBildMasterOff
 global MasterBildSlaveOff
 global FocusEditorFlag
 global FocusEditor
 if $MasterFlag then {
  if [string compare $Master $NEW] then {
   $NEW.todo.master configure -image $MasterBildSlaveOn
  } else {
   $NEW.todo.master configure -image $MasterBildMasterOn
  }
  if $FocusEditorFlag then {
   if [string compare $NEW $OLD] then {
    if [string compare $Master $OLD] then {
     $OLD.todo.master configure -image $MasterBildSlaveOff
    } else {
     $OLD.todo.master configure -image $MasterBildMasterOff
  }}}
 } else {
  $NEW.todo.master configure -image $MasterBildSlaveOn
  if [string compare $NEW $OLD] then { 
   if $FocusEditorFlag then { $OLD.todo.master configure -image $MasterBildSlaveOff}
  }} 
 set FocusEditorFlag 1
 set FocusEditor $NEW
}
proc MasterBefehl {E BEFEHL FILE OPTION msgflag} {
 global MasterFlag
 global Master
 global FilenameArray
 global tcl_platform
 global ModifiedArray
 if $MasterFlag then {
  set Q $Master 
 } else {
  set Q $E
 }
 set A "I"
 eval "set FILEK \"$FILE\""
 eval "set OPTIONK \"$OPTION\""
 if $msgflag then {
  set nowpath [pwd]
  cd [file dirname $FILEK]
  switch $tcl_platform(platform) unix {
   # unix und linux Programme
   switch $BEFEHL latex {
    catch {exec xterm -e $BEFEHL $FILEK $OPTIONK} error 
    set FILELOG  [string range $FILEK 0 [expr [string length $FILEK] - 5]].log
    if [file exists $FILELOG] then {
     set f [open $FILELOG r]
     set error [read $f]
     set t [close $f]
    }
   } default {
    catch {set error [exec $BEFEHL $FILEK $OPTIONK]} error
   } 
  } windows {
   catch {exec $BEFEHL $FILEK $OPTIONK} error
  } 
  cd $nowpath
  global FocusEditorFlag
  global FocusEditor
  global hlppath
  set ksp $E.wmsg
  if ![winfo exists $ksp] then { 
   toplevel $E.wmsg
   Cframe $E.wmsg
   frame $E.wmsg.f
   Cframe $E.wmsg.f
   scrollbar $E.wmsg.f.vscroll -relief sunken -command "$E.wmsg.f.l yview" 
   
   Cscrollbar $E.wmsg.f.vscroll
   text $E.wmsg.f.l -yscroll "$E.wmsg.f.vscroll set" 
   Ctext $E.wmsg.f.l
   pack $E.wmsg.f.vscroll  -side right -fill y
   pack $E.wmsg.f.l -expand yes -fill both
   button $E.wmsg.butQ -text "Quit" -command "destroy $E.wmsg"
   
    Cbutton $E.wmsg.butQ
   pack $E.wmsg.f $E.wmsg.butQ
   wm title $E.wmsg "message"
  }
  $E.wmsg.f.l configure -state normal 
  $E.wmsg.f.l delete 1.0 end
  $E.wmsg.f.l insert 1.0 $error
  $E.wmsg.f.l configure -state disabled 
  $E.wmsg.f.l see end
  focus $E.wmsg
 } else {
  catch {exec $BEFEHL $FILEK &} error
#  catch {exec $BEFEHL $FILEK $OPTIONK &} error
 }
}
proc EDITORQUIT {E} {
 global ModifiedArray
 if $ModifiedArray($E.te.edit1) then {
   set sp [tk_dialog $E.wquit Quit "Vorher Speichern ?" {} 0 Save Quit Cancel]
   switch $sp 0 {
    SaveFile $E
    destroy $E
   } 1 {
    destroy $E
   }
 } else {destroy $E}
}
proc EDITOR {} {
 global FilenameArray EDITORNUMMER MasterBildSlaveOn ModifiedArray UndoArray FocusEditor
 global latex_exec xdvi_exec dvips_exec ghostview_exec
 global BeginFlag BeginRealy
 global erg_flag
 global BlockColor SyntaxColorGreen SyntaxColorRed SyntaxColorBlue ErgaenzungGray
 incr EDITORNUMMER
 set E ".editor$EDITORNUMMER"
 set FilenameArray($E) scratch
 set UndoArray($E.te.edit1) ""
 set BeginFlag($E.te.edit1) 0
 set BeginRealy($E.te.edit1) 0
 set erg_flag($E.te.edit1) 0
 toplevel $E
 Cframe $E
 frame $E.todo
 Cframe $E.todo 
 button $E.todo.master -image $MasterBildSlaveOn -command "Master $E"
 
 button $E.todo.save -text "Save" -command "SaveFile $E"
 
 button $E.todo.saveas -text "SaveAs" -command "SaveAsFile $E"
  
 button $E.todo.latex -text "latex" -command "SaveFile $E\n MasterBefehl $E \"$latex_exec\" \"\\\$FilenameArray(\\\$Q)\" \"\" 1"
 
 button $E.todo.xdvi -text "xdvi" -command "MasterBefehl $E \"$xdvi_exec\" \"\\\[string range \\\$FilenameArray(\\\$Q) 0 \\\[expr \\\[string length \\\$FilenameArray(\\\$Q)\] - 5\\\]\\\].dvi\" \"\" 0"
 
 button $E.todo.dvips -text "dvips" -command "MasterBefehl $E \"$dvips_exec\" \"\\\[string range \\\$FilenameArray(\\\$Q) 0 \\\[expr \\\[string length \\\$FilenameArray(\\\$Q)\] - 5\\\]\\\].dvi\" \"-o\\\[string range \\\$FilenameArray(\\\$Q) 0 \\\[expr \\\[string length \\\$FilenameArray(\\\$Q)\\\] - 5\\\]\\\].ps\" 1"
 
 button $E.todo.gv -text "ghostview" -command "MasterBefehl $E \"$ghostview_exec\" \"\\\[string range \\\$FilenameArray(\\\$Q) 0 \\\[expr \\\[string length \\\$FilenameArray(\\\$Q)\\\] - 5\\\]\\\].ps\" \"\" 0"
 
 Cbutton $E.todo.master
 Cbutton $E.todo.save
 Cbutton $E.todo.saveas
 Cbutton $E.todo.latex
 Cbutton $E.todo.xdvi
 Cbutton $E.todo.dvips
 Cbutton $E.todo.gv

 label $E.todo.pos -text "Z.S 0.0" -width 12
 Cframe $E.todo.pos
 button $E.todo.syntax -text "Syntax" -command "Syntax $E.te.edit1"
 button $E.todo.quit -text "Quit" -command "EDITORQUIT $E"
 
 Cbutton $E.todo.syntax
 Cbutton $E.todo.quit
 pack $E.todo.master $E.todo.save $E.todo.saveas $E.todo.latex $E.todo.xdvi $E.todo.dvips $E.todo.gv $E.todo.syntax $E.todo.quit $E.todo.pos -side left -fill x
 pack $E.todo -fill x

 frame $E.te -relief raised -borderwidth 2
 Cframe $E.te
 scrollbar $E.te.vscroll -relief sunken -command "$E.te.edit1 yview"
 text $E.te.edit1 -yscroll "$E.te.vscroll set"
 
 Cscrollbar $E.te.vscroll
 Ctext $E.te.edit1
 pack $E.te.vscroll  -side right -fill y
 pack $E.te.edit1 -expand yes -fill both
 pack $E.te  -expand yes -fill both
 bind $E.te.edit1 <<Help>> {HelpTo %W}
 bind $E.te.edit1 <Control-k><x> {SaveFile %W}
 bind $E.te.edit1 <Control-k><d> {SaveAsFile %W}
 bind $E <FocusIn> "erg_proc $E.te.edit1 \n MasterFocus $E \$FocusEditor"
 MasterFocus $E $FocusEditor
 bind $E.te.edit1 <Delete> {
  if $erg_flag(%W) then {
    proc_undo %W    
    set erg_flag(%W) 0
    break
  } else {
   switch_undo %W Delete
  }
 }
 bind $E.te.edit1 <BackSpace> {
  switch_undo %W BackSpace
  event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
 }
 bind $E.te.edit1 <Control-d> {
  switch_undo %W Delete
 }
 set ModifiedArray($E.te.edit1) 0
 bind $E.te.edit1 <<Position>> "event generate $E.te.edit1 <<Position_tail>> -when tail"
 bind $E.te.edit1 <<Position_tail>> "$E.todo.pos configure -text \"Z.S \[$E.te.edit1 index insert\]\""
 bind  $E.te.edit1 <<Modified>> {
  set ModifiedArray(%W) 1
 }
 bind $E.te.edit1 <<ERG>> {
  ergaenzung %W
 }
 bind $E.te.edit1 <<BeginFlag>> {
  if $BeginRealy(%W) {
   switch_undo %W insert
   UndoMul %W 2
  }
  set BeginFlag(%W) 0
  set BeginRealy(%W) 0
  erg_proc %W
  event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
 }
 bind $E.te.edit1 <<proc_undo>> {
  switch_undo %W insert
  event generate $FocusEditor.te.edit1 <<BeginFlag>>
 }
 wm protocol $E WM_DELETE_WINDOW "EDITORQUIT $E"
 menu $E.pop_menu 
 $E.pop_menu add command -label "Undo" -command "pop_menu $E.te.edit1 Undo"
 $E.pop_menu add separator
 $E.pop_menu add command -label "Cut" -command "pop_menu $E.te.edit1 Cut"
 $E.pop_menu add command -label "Copy" -command "pop_menu $E.te.edit1 Copy"
 $E.pop_menu add command -label "Paste" -command "pop_menu $E.te.edit1 Paste" 
 $E.pop_menu add command -label "Clear" -command "pop_menu $E.te.edit1 Clear" 
 $E.pop_menu add separator
 $E.pop_menu add command -label "Block" -command "pop_menu $E.te.edit1 Block" 
 $E.pop_menu add command -label "+ %" -command "pop_menu $E.te.edit1 AusKomm"
 $E.pop_menu add command -label "- %" -command "pop_menu $E.te.edit1 AusKommRueck"
 if {[lindex [split [info tclversion] .] 0] > 7} {$E configure -menu $E.pop_menu}
 bind $E.te.edit1 <Button-3> "tk_popup $E.pop_menu \[winfo pointerx $E\] \[winfo pointery $E\]"
 bind $E.te.edit1 <ssharp> {
  if {[%W tag nextrange sel 1.0 end] != ""} {
   switch_undo %W insert
   %W insert sel.last "\}" 
   %W tag add undo sel.last sel.last+1c 
   %W mark set insert sel.first
   %W insert insert "\{\\"
   %W tag add undo insert-2c insert
   %W tag remove sel 1.0 end
   switch_undo %W insert
   UndoMul %W 2
   break 
  }
 } 
 $E.te.edit1 tag add syntax_blue 1.0 1.0
 $E.te.edit1 tag add syntax_red 1.0 1.0
 $E.te.edit1 tag add syntax_green 1.0 1.0
 $E.te.edit1 tag add BlockTag 1.0 1.0
 $E.te.edit1 tag add erg_tag 1.0 1.0
 $E.te.edit1 tag raise syntax_red
 $E.te.edit1 tag raise syntax_green
 $E.te.edit1 tag raise syntax_blue
 $E.te.edit1 tag raise BlockTag
 $E.te.edit1 tag raise erg_tag
 $E.te.edit1 tag raise sel
 $E.te.edit1 tag configure syntax_blue -foreground $SyntaxColorBlue
 $E.te.edit1 tag configure syntax_green -foreground $SyntaxColorGreen
 $E.te.edit1 tag configure syntax_red -foreground $SyntaxColorRed
 $E.te.edit1 tag configure BlockTag -background $BlockColor
 $E.te.edit1 tag configure erg_tag -background $ErgaenzungGray

 return $E
}
proc pop_menu {E Fall} {
 global BlockBeginFlag BlockEndFlag BlockEditor BlockColor UndoArray
 switch $Fall Cut {
   switch_undo $E sel
   tk_textCut $E
 } Copy {
  tk_textCopy $E
 }  Paste {
  switch_Undo $E UndoBeginSel
  tk_textPaste $E
  switch_Undo $E UndoEnd
 } Clear {
  if {[$E tag nextrange sel 1.0 end] != ""} {
   switch_undo $E sel
   $E delete sel.first sel.last
  }
 } Block {
  if {[$E tag nextrange sel 1.0 end] != ""} {
   if {$BlockBeginFlag && $BlockEndFlag} then {$BlockEditor tag remove BlockTag 1.0 end}
   set BlockBeginFlag 1
   set BlockEndFlag 1
   set BlockEditor $E
   $E mark set BlockBegin [$E index sel.first]
   $E mark set BlockEnd [$E index sel.last]
   $E mark gravity BlockEnd left
   $E tag add BlockTag BlockBegin BlockEnd
  }
 } AusKomm {
  if {[$E tag nextrange sel 1.0 end] != ""} {
   AusKomm $E sel.first sel.last
  }
 } AusKommRueck {
  if {[$E tag nextrange sel 1.0 end] != ""} {
   AusKommRueck $E sel.first sel.last
  }
 } Undo {
  proc_undo $E
 }
}

######################################################################
proc NewFile {} {
 global FocusEditor
 global FilenameArray
 global EDITORNUMMER
 global etcpath
 set E [EDITOR]
 $E.te.edit1 delete 1.0 end
 set FilenameArray($E) ""
 wm title $E "no name $EDITORNUMMER"
 if [file exists "$etcpath/default.tex"] then {
  set f [open "$etcpath/default.tex" r]
  set x [read $f]
  $E.te.edit1 insert 1.0 $x
  set t [close $f]
 } else {
  $E.te.edit1 insert end "\\documentclass\[12pt,a4paper\]{report}\n"
  $E.te.edit1 insert end "\\usepackage\[german\]{babel}\n"
  $E.te.edit1 insert end "\\usepackage{umlaut}\n"
  $E.te.edit1 insert end "\\begin{document}\n\n"
  $E.te.edit1 insert end "\\end{document}\n"
 }
 event generate $E <<Position_tail>> -when tail
}

proc LoadFile {} {
 global FilenameArray
 global ModifiedArray
 set types {
    {{latex Files} {.tex} }
    {{plain Text} {.txt}}
    {{All Files}        *}
 }
 set filename [tk_getOpenFile -filetypes $types]
 if {$filename != ""} then {
  set E [EDITOR]
  set f [open $filename r]
  set x [read $f]
  $E.te.edit1 insert 1.0 $x
  set t [close $f]
  #Set global filename
  set FilenameArray($E) $filename
  wm title $E "$filename"
  event generate $E.te.edit1 <<Modified>>
 }
}

proc AppendFile {E} {
 set types {
    {{latex Files} {.tex} }
    {{plain Text} {.txt}}
    {{All Files}        *}
 }
 set filename [tk_getOpenFile -filetypes $types]
 if {$filename != ""} then {
  set f [open $filename r]
  set x [read $f]
  #Append file at end of text
  $E.te.edit1 insert insert $x
  #Close source file
  set t [close $f]
  event generate $E.te.edit1 <<Modified>>
}}

proc SaveFile {E} {
 global FilenameArray
 global ModifiedArray
 if {$FilenameArray($E)!= ""} then {
  set f [open $FilenameArray($E) w]
  #Get text to save
  set x [$E.te.edit1 get 1.0 end]
  #Save it
  puts $f $x
  #and close file
  set t [close $f]
  set ModifiedArray($E.te.edit1) 0
  set ModifiedArrayl($E.te.edit1) [string length $x]
 } else {SaveAsFile $E}
}

proc SaveAsFile {E} {
 global FilenameArray
 global ModifiedArray
 set types {
    {{latex Files} {.tex} }
    {{plain Text} {.txt}}
    {{All Files}        *}
 }
 set filename [tk_getSaveFile -filetypes $types -initialfile "$FilenameArray($E)" -defaultextension ".tex"]
 if {$filename != ""} then {
  set f [open $filename w]
  #Get text to save
  set x [$E.te.edit1 get 1.0 end]
  #Save it
  puts $f $x
  #and close file
  set t [close $f]
  set FilenameArray($E) $filename
  wm title $E "$FilenameArray($E)"
  set ModifiedArray($E.te.edit1) 0
}}


####################################################################
# Setzt backslash's fuer eine Stringuebergabe ein
proc backslash {s} {
 set begin_s ""
 set end_s $s
 set pos 0
 while {$pos != 10000} {
 set key ""
  set pos "10000"
  set kpos [string first "\"" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\\""
  }}
  set kpos [string first "\\" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\\\"
  }}
  set kpos [string first "\n" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\n"
  }}
  set kpos [string first "\t" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\t"
  }}
  set kpos [string first "\[" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\\["
  }}

  set kpos [string first "\]" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\\]"
  }}
  set kpos [string first "\{" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\\{"
  }}

  set kpos [string first "\}" $end_s]
  if {$pos > $kpos} then {
   if {$kpos != -1} then {
    set pos $kpos
    set key "\\\}"
  }}

  if {$pos != 10000} then {
   set begin_s $begin_s[string range $end_s 0 [expr $pos - 1]]$key
   set end_s "[string range $end_s [expr $pos + 1] end]"
  } else {return "$begin_s$end_s"}
}}
####################################################################
proc InitSearch {} {
 global FocusEditorFlag
 global FocusEditor
 if ![winfo exists .wsearch] then {
  toplevel .wsearch
  Cframe .wsearch
  wm title .wsearch "search"
  entry .wsearch.text1 -width 20 -relief sunken
  entry .wsearch.text2 -width 20 -relief sunken
  Ctext .wsearch.text1
  Ctext .wsearch.text2
  global wsearch_gb

  checkbutton .wsearch.butgb -variable wsearch_gb -text "case sensitive"
  Cmenu .wsearch.butgb
  button .wsearch.but1 -text "Search" -command {
   if $FocusEditorFlag then {
    focus $FocusEditor.te.edit1
    set Text [.wsearch.text1 get]
    if !$wsearch_gb then {set comm "-nocase"} else {set comm "--"}
    set ksp [$FocusEditor.te.edit1 search $comm "$Text" 1.0]
    if { [string length $ksp] > 0 } then {
     $FocusEditor.te.edit1 mark set insert $ksp
     $FocusEditor.te.edit1 see insert
     $FocusEditor.te.edit1 tag remove sel 1.0 end
     $FocusEditor.te.edit1 tag add sel insert "insert + [string length $ksp] chars"
     event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
  }}}
  frame .wsearch.f1
  Cframe .wsearch.f1
  button .wsearch.f1.but2 -text "down" -command {
   if $FocusEditorFlag then {
    focus $FocusEditor.te.edit1
    set Text [.wsearch.text1 get]
    if !$wsearch_gb then {set comm "-nocase"} else {set comm "--"}
    set ksp [$FocusEditor.te.edit1 search $comm "$Text" "insert + 1 chars"]
    if { [string length $ksp] > 0 } then {
    $FocusEditor.te.edit1 mark set insert $ksp
     $FocusEditor.te.edit1 see insert
     $FocusEditor.te.edit1 tag remove sel 1.0 end
     $FocusEditor.te.edit1 tag add sel insert "insert + [string length $ksp] chars"
     event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
   }}}
  button .wsearch.f1.but3 -text "up" -command {
   if $FocusEditorFlag then {
    focus $FocusEditor.te.edit1
    set Text [.wsearch.text1 get]
    if { [string length "$Text"] > 0 } then {
     if !$wsearch_gb then {set comm "-nocase"} else {set comm "-exact"}
     set ksp [$FocusEditor.te.edit1 search -backwards $comm "$Text" insert]
     if { [string length $ksp] > 0 } then {
      $FocusEditor.te.edit1 mark set insert $ksp
      $FocusEditor.te.edit1 see insert
      $FocusEditor.te.edit1 tag remove sel 1.0 end
      $FocusEditor.te.edit1 tag add sel insert "insert + [string length $ksp] chars"
      event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
   }}}}
  frame .wsearch.f2
  Cframe .wsearch.f2
  button .wsearch.f2.but4 -text "replace" -command {
   if $FocusEditorFlag then {
    focus $FocusEditor.te.edit1
    set FIND [.wsearch.text1 get]
    set FIND_L [string length "$FIND"]
    if { $FIND_L > 0} then { 
     set NOW [$FocusEditor.te.edit1 get insert "insert + $FIND_L chars"]
     if ![string compare "$NOW" "$FIND"] then {
      # Ersetzt
      $FocusEditor.te.edit1 delete insert "insert + $FIND_L chars"
      set REPLACE [.wsearch.text2 get]
      $FocusEditor.te.edit1 insert insert "$REPLACE"
      $FocusEditor.te.edit1 see insert
      event generate $FocusEditor.te.edit1 <<Modified>>
     }
     # Sucht
     if !$wsearch_gb then {set comm "-nocase"} else {set comm "--"}
     set ksp [$FocusEditor.te.edit1 search $comm "$FIND" insert]
     if [string length $ksp] then {
      $FocusEditor.te.edit1 mark set insert $ksp
      $FocusEditor.te.edit1 see insert
      $FocusEditor.te.edit1 tag remove sel 1.0 end
      $FocusEditor.te.edit1 tag add sel insert "insert + [string length $ksp] chars"
      $FocusEditor.te.edit1 mark set sel.first insert
      event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
  }}}}
  button .wsearch.f2.but5 -text "all" -command {
   if $FocusEditorFlag then {
    focus $FocusEditor.te.edit1
    set FIND [.wsearch.text1 get]
    set FIND_L [string length "$FIND"]
    if {$FIND_L > 0} then { 
     set all_l 1
     while $all_l {
      set NOW [$FocusEditor.te.edit1 get insert "insert + $FIND_L chars"]
      if ![string compare "$NOW" "$FIND"] then {
       # Ersetzt
       $FocusEditor.te.edit1 delete insert "insert + $FIND_L chars"
       set REPLACE [.wsearch.text2 get]
       $FocusEditor.te.edit1 insert insert "$REPLACE"
       $FocusEditor.te.edit1 see insert
       event generate $FocusEditor.te.edit1 <<Modified>>
      }
      # Sucht
      if !$wsearch_gb then {set comm "-nocase"} else {set comm "--"}
      set all_string [$FocusEditor.te.edit1 search $comm "$FIND" insert]
      if [string length $all_string] then {
       $FocusEditor.te.edit1 mark set insert $all_string
      } else {break}
      set all_l [string length $all_string]
     }
     $FocusEditor.te.edit1 see insert
     event generate $FocusEditor.te.edit1 <<Position_tail>> -when tail
    }
   }
  }
  button .wsearch.butQ -text "Quit" -command {
   destroy .wsearch
  }
  Cbutton .wsearch.but1
  Cbutton .wsearch.f1.but2
  Cbutton .wsearch.f1.but3
  Cbutton .wsearch.f2.but4
  Cbutton .wsearch.f2.but5
  Cbutton .wsearch.butQ
  pack  .wsearch.f1.but2 -side left
  pack .wsearch.f1.but3 -side right
  pack .wsearch.f2.but4 .wsearch.f2.but5 -side left
  pack .wsearch.text1 .wsearch.but1 .wsearch.f1 .wsearch.butgb .wsearch.text2 .wsearch.f2 .wsearch.butQ
  wm minsize . 1 1
  bind .wsearch <<Help>> {Help tcltexed_hlp Search}
  bind .wsearch <Control-c> {
   destroy .wsearch
 }}
 wm resizable .wsearch 0 0
}
###################################################################
proc FRLIAN {FRAME LISTE ANZ START} {
 global LISTEK1
 global txtpath
 global gifpath
 global hlppath
 global I_befehl
 global I_hlp
 global I_txt
 global I_back
 set ii 1
 set fr 1
 frame $FRAME.$START$fr
 Cframe $FRAME.$START$fr
 foreach i $LISTE {
  set tb [image create photo  -file "$gifpath/$I_txt($i).gif"] 
  set x [backslash $I_befehl($i)]
  button $FRAME.$START$fr.but$i -image $tb -command "if \$FocusEditorFlag then {focus \$FocusEditor.te.edit1 \n switch_Undo \$FocusEditor.te.edit1 UndoBegin\n\$FocusEditor.te.edit1 insert insert \"$x\"\nswitch_Undo \$FocusEditor.te.edit1 UndoEnd\nswitch_undo \$FocusEditor.te.edit1 insert\n\$FocusEditor.te.edit1 mark set insert \"insert - $I_back($i) chars\"\n  event generate \$FocusEditor.te.edit1 <<Modified>>}"

  Cbutton $FRAME.$START$fr.but$i
  bind $FRAME.$START$fr.but$i <<Help>> "Help $I_hlp($i) $i"
  bind $FRAME.$START$fr.but$i <<HelpHelp>> "Help $I_hlp($i) $i"
  if {$ii == $ANZ} then {
   set ii 0
   incr fr
   frame $FRAME.$START$fr
   Cframe $FRAME.$START$fr
  }  
  incr ii
 }
 set ii 1
 set fr 1
 foreach i $LISTE {
  pack $FRAME.$START$fr.but$i -side left
  if {$ii == $ANZ} then {
   pack $FRAME.$START$fr -side top
   set ii 0
   incr fr
  }  
  incr ii
 }
 pack $FRAME.$START$fr -side top
}
#######################################################################
proc Help {FILE Name} {
 global FocusEditorFlag
 global FocusEditor
 global hlppath
 global gifpath
 global I_txt
 global I_hlp
# if { [lsearch -exact [array names I_txt] $Name] != -1} then {
#  set FILE_hlp $I_hlp($Name)
#  set FILE_gif $I_txt($Name) 
# } else {
#  set FILE_hlp $Name
#  set FILE_gif $Name
# }
 if [file exists "$hlppath/$FILE.txt"] then {
  set f [open "$hlppath/$FILE.txt" r]
  set txt [read $f]
  close $f
  if ![winfo exists .whelp] then { 
   toplevel .whelp
   Cframe .whelp
   frame .whelp.f
   Cframe .whelp.f
   scrollbar .whelp.f.vscroll -relief sunken -command {.whelp.f.l yview}
   Cscrollbar .whelp.f.vscroll 
   text .whelp.f.l -yscroll {.whelp.f.vscroll set}
   Ctext .whelp.f.l 
   .whelp.f.l insert 1.0 $txt
   .whelp.f.l configure -state disabled 
   pack .whelp.f.vscroll  -side right -fill y
   pack .whelp.f.l -expand yes -fill both
   button .whelp.butQ -text "Quit" -command {
    destroy .whelp
   }
   Cbutton .whelp.butQ
   pack .whelp.f -expand yes -fill y
   pack .whelp.butQ
   set ksp [.whelp.f.l search $Name 1.0]
   if {$ksp != ""} then {.whelp.f.l see $ksp}
  } else {
   .whelp.f.l configure -state normal 
   .whelp.f.l delete 1.0 end
   .whelp.f.l insert 1.0 $txt
   .whelp.f.l configure -state disabled
   set ksp [.whelp.f.l search $Name 1.0]
   if {$ksp != ""} then {.whelp.f.l see $ksp}
   focus .whelp 
  }
 } 
 if [file exists "$gifpath/$FILE.gif"] then {
  set tb [image create photo  -file "$gifpath/$FILE.gif"] 
  if ![winfo exists .whelpgif] then { 
   toplevel .whelpgif
   Cframe .whelpgif
 
   button .whelpgif.butQ -image $tb -command {
    destroy .whelpgif
   }
   Cbutton .whelpgif.butQ
   pack .whelpgif.butQ
  } else {
   .whelpgif.butQ configure -image $tb 
   focus .whelpgif
  }
 }
}
set packstring ""
proc addpack {T} { 
 global packstring
 set packstring "$packstring $T"
}
proc buttonmake {NAME buttonmakecount latex} {
 global I_befehl
 global I_hlp
 global I_txt
 global I_back
 set t "[backslash "$I_befehl($latex)"]"
 button $NAME.but$buttonmakecount -text $I_txt($latex)  -command "if \$FocusEditorFlag then {\n focus \$FocusEditor.te.edit1 \n switch_Undo \$FocusEditor.te.edit1 UndoBegin\n\$FocusEditor.te.edit1 insert insert \"$t\"\nswitch_Undo \$FocusEditor.te.edit1 UndoEnd\nswitch_undo \$FocusEditor.te.edit1 insert\n\$FocusEditor.te.edit1 mark set insert \"insert - $I_back($latex) chars\"\n event generate \$FocusEditor.te.edit1 <<Modified>>}"
 Cbutton $NAME.but$buttonmakecount 
 bind $NAME.but$buttonmakecount <<Help>> "Help $I_hlp($latex) $latex"
 bind $NAME.but$buttonmakecount <<HelpHelp>> "Help $I_hlp($latex) $latex"
 addpack $NAME.but$buttonmakecount
}
proc HelpTo {NAME} {
 global I_hlp
 set flag 1
 set key [$NAME get insert "insert + 1 chars"]
 if ![string compare $key "\\"] then {
  set strt "insert + 1 chars"
 } else {
  set strt "insert"
 }
 set ID [array startsearch I_hlp] 
 while {[array anymore I_hlp $ID]} {
  set elm [array nextelement I_hlp $ID]
  set velm [$NAME get $strt "insert + [expr [string length "$elm"] + 1] chars"]
  if ![string compare "$elm" "$velm"] then {
   Help $I_hlp($elm) $elm
   set flag 0
  }
 }
 array donesearch I_hlp $ID
 if $flag then {
   Help editor_hlp ""
 }
}
proc ergaenzung {E} {
 global I_befehl
 global I_back
 global I_state
 global BeginFlag
 global erg_flag
 global erg_back
 set ksp [$E get "insert - 1 chars wordstart - 1 chars" "insert - 1 chars wordstart"]
 if ![string compare "\\" $ksp] then {
  set TEXT [$E get "insert - 1 chars wordstart" insert]
  set ksp [array names I_state "$TEXT*"]
  if {1 == [llength $ksp]} then {
   if {[string length $ksp] > [string length $TEXT]} then {
    set erg_flag($E) 1
    switch_undo $E ErgDel 
    $E delete "insert - 1 chars wordstart - 1 chars" insert
    switch_Undo $E UndoBegin
    $E mark set erg_begin insert
    $E mark gravity erg_begin left
    $E insert insert $I_befehl($ksp)
    $E mark set erg_end insert
    switch_Undo $E UndoEnd
    switch_undo $E insert
    UndoMul $E 2
    switch $ksp begin {
     $E mark set BeginMark "insert - 2 chars"
     set BeginFlag($E) 1
    }
    $E tag add erg_tag erg_begin erg_end
    $E mark set insert "insert - [expr [string length $I_befehl($ksp)] - [string length $TEXT] - 1] chars" 
    set erg_back($E) $I_back($ksp)
   }
  }
 }
}
proc erg_proc {E} {
 global erg_flag
 global erg_back
 if $erg_flag($E) then {
  $E mark set insert "erg_end - $erg_back($E) chars"
  $E tag remove erg_tag 1.0 end
  set erg_flag($E) 0
 }
}
##################################################################################
# latex Listen
proc InitListen {} {
 global I_befehl I_hlp I_back
 if ![winfo exists .wlisten] then {
  toplevel .wlisten
  Cframe .wlisten
  wm title .wlisten "latex"
  frame .wlisten.e
  Cframe .wlisten.e
  scrollbar .wlisten.e.scroll -command { .wlisten.e.list yview }
  Cscrollbar .wlisten.e.scroll
  pack .wlisten.e.scroll -side right -fill y
  listbox .wlisten.e.list -yscroll ".wlisten.e.scroll set" -relief sunken -width 20 -height 20 -setgrid yes
  Ctext .wlisten.e.list
  pack .wlisten.e.list  -fill both -expand yes
  set LISTE [lsort [array names I_befehl]]
  foreach i $LISTE {.wlisten.e.list insert end $i}
  button .wlisten.butQ -text Quit -command {destroy .wlisten}
  Cbutton .wlisten.butQ
  pack .wlisten.e .wlisten.butQ -fill x
  wm minsize . 1 1

  bind .wlisten <<Help>> {
   if {[.wlisten.e.list curselection] != ""} then {
    Help $I_hlp([selection get]) [selection get]
   } else {
    Help tcltexed_hlp Help
   }
  }
  bind .wlisten <Return> {
   set ksp [.wlisten.e.list curselection]
   if {$ksp != ""} then {
    Help $I_hlp([selection get]) [selection get]
    focus .wlisten
    if {$ksp < [.wlisten.e.list size]} then {incr ksp}
    .wlisten.e.list selection clear 0 end
    .wlisten.e.list selection set $ksp $ksp
    .wlisten.e.list see $ksp  
   }
  }
  bind .wlisten <Double-Button-1> {
   if {[.wlisten.e.list curselection] != ""} then {
    Help $I_hlp([selection get]) [selection get]
    focus .wlisten
   }
  }
  bind .wlisten <Double-Button-3> {
   if {[.wlisten.e.list curselection] != ""} then {
    if $FocusEditorFlag then {
     focus $FocusEditor.te.edit1 
     switch_Undo $FocusEditor.te.edit1 UndoBegin
     $FocusEditor.te.edit1 insert insert $I_befehl([selection get])
     switch_Undo $FocusEditor.te.edit1 UndoEnd
     switch_undo $FocusEditor.te.edit1 insert
     $FocusEditor.te.edit1 mark set insert "insert - $I_back([selection get]) chars"
     event generate $FocusEditor.te.edit1 <<Modified>>
    }
   }
  }
  bind .wlisten <Prior> {
   set ksp [.wlisten.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp > 20} then {set ksp [expr $ksp - 20]}
    .wlisten.e.list selection clear 0 end
    .wlisten.e.list selection set $ksp $ksp
    .wlisten.e.list see $ksp  
   }
  }
  bind .wlisten <Next> {
   set ksp [.wlisten.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp < [expr 20 + [.wlisten.e.list size]]} then {set ksp [expr $ksp + 20]}
    .wlisten.e.list selection clear 0 end
    .wlisten.e.list selection set $ksp $ksp
    .wlisten.e.list see $ksp  
   }
  }
  bind .wlisten <Up> {
   set ksp [.wlisten.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp > 0} then {set ksp [expr $ksp - 1]}
    .wlisten.e.list selection clear 0 end
    .wlisten.e.list selection set $ksp $ksp
    .wlisten.e.list see $ksp  
   }
  }
  bind .wlisten <Down> {
   set ksp [.wlisten.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp < [.wlisten.e.list size]} then {incr ksp}
    .wlisten.e.list selection clear 0 end
    .wlisten.e.list selection set $ksp $ksp
    .wlisten.e.list see $ksp  
   }
  }
  bind .wlisten <Control-c> {
   destroy .wlisten
  }
 }
}
##################################################################################
# latex Tcltexed
proc InitTcltexed {} {
 global Tcltexed_help
 if ![winfo exists .wTcltexed] then {
  toplevel .wTcltexed
  Cframe .wTcltexed
  wm title .wTcltexed "Help"
  frame .wTcltexed.e
  Cframe .wTcltexed.e
  scrollbar .wTcltexed.e.scroll -command { .wTcltexed.e.list yview }
  Cscrollbar .wTcltexed.e.scroll
  pack .wTcltexed.e.scroll -side right -fill y
  listbox .wTcltexed.e.list -yscroll ".wTcltexed.e.scroll set" -relief sunken -width 20 -height 20 -setgrid yes
  Ctext .wTcltexed.e.list
  pack .wTcltexed.e.list  -fill both -expand yes
  .wTcltexed.e.list insert end "Tcltexed"
  set Tcltexed_help(Tcltexed) tcltexed_hlp
  .wTcltexed.e.list insert end "Editor"
  set Tcltexed_help(Editor) editor_hlp
  .wTcltexed.e.list insert end "Editor-Tastenbelegung"
  set Tcltexed_help(Editor-Tastenbelegung) editort_hlp
  .wTcltexed.e.list insert end "Readme"
  set Tcltexed_help(Readme) readme_hlp
  .wTcltexed.e.list insert end "Copyright"
  set Tcltexed_help(Copyright) copyright_hlp
  .wTcltexed.e.list insert end "Gnu-Puplic-License"
  set Tcltexed_help(Gnu-Puplic-License) gpl_hlp
  button .wTcltexed.butQ -text Quit -command {destroy .wTcltexed}
  Cbutton .wTcltexed.butQ
  pack .wTcltexed.e .wTcltexed.butQ -fill x
  wm minsize . 1 1

  bind .wTcltexed <<Help>> {
   if {[.wTcltexed.e.list curselection] != ""} then {
    Help $Tcltexed_help([selection get]) ""
   } else {
    Help tcltexed_hlp Help
   }
  }
  bind .wTcltexed <Return> {
   set ksp [.wTcltexed.e.list curselection]
   if {$ksp != ""} then {
    Help $Tcltexed_help([selection get])
    focus .wTcltexed
    if {$ksp < [.wTcltexed.e.list size]} then {incr ksp}
    .wTcltexed.e.list selection clear 0 end
    .wTcltexed.e.list selection set $ksp $ksp
    .wTcltexed.e.list see $ksp  
   }
  }
  bind .wTcltexed <Double-Button-1> {
   if {[.wTcltexed.e.list curselection] != ""} then {
    Help $Tcltexed_help([selection get]) ""
    focus .wTcltexed
   }
  }
  bind .wTcltexed <Double-Button-3> {
   if {[.wTcltexed.e.list curselection] != ""} then {
    Help $Tcltexed_help([selection get]) ""
    focus .wTcltexed
   }
  }
  bind .wTcltexed <Prior> {
   set ksp [.wTcltexed.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp > 20} then {set ksp [expr $ksp - 20]}
    .wTcltexed.e.list selection clear 0 end
    .wTcltexed.e.list selection set $ksp $ksp
    .wTcltexed.e.list see $ksp  
   }
  }
  bind .wTcltexed <Next> {
   set ksp [.wTcltexed.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp < [expr 20 + [.wTcltexed.e.list size]]} then {set ksp [expr $ksp + 20]}
    .wTcltexed.e.list selection clear 0 end
    .wTcltexed.e.list selection set $ksp $ksp
    .wTcltexed.e.list see $ksp  
   }
  }
  bind .wTcltexed <Up> {
   set ksp [.wTcltexed.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp > 0} then {set ksp [expr $ksp - 1]}
    .wTcltexed.e.list selection clear 0 end
    .wTcltexed.e.list selection set $ksp $ksp
    .wTcltexed.e.list see $ksp  
   }
  }
  bind .wTcltexed <Down> {
   set ksp [.wTcltexed.e.list curselection]
   if {$ksp != ""} then {
    if {$ksp < [.wTcltexed.e.list size]} then {incr ksp}
    .wTcltexed.e.list selection clear 0 end
    .wTcltexed.e.list selection set $ksp $ksp
    .wTcltexed.e.list see $ksp  
   }
  }
  bind .wTcltexed <Control-c> {
   destroy .wTcltexed
  }
 }
}
######################################################
proc proc_undo {E} {
 global UndoArray 
  event generate $E <<proc_undo>>
  if {[llength $UndoArray($E)] != 0} then {
  set liste [lindex $UndoArray($E) end]
  set UndoArray($E) [lrange $UndoArray($E) 0 [expr [llength $UndoArray($E)] - 2]]
  switch [lindex $liste 0] insert {
   $E insert [lindex $liste 1] "[lindex $liste 2]"
  } delete {
   $E delete [lindex $liste 1] [lindex $liste 2]
  } UndoMul {
   set I 0
   set I_max [lindex $liste 1]
   for {set I 0} {$I < $I_max} {incr I} {proc_undo $E}
  }
 }
}
proc insert_undo {E} {
 global UndoArray
 if {[$E tag nextrange undo 1.0 end] != ""} then {
  set flag 0
  foreach {A O} [$E tag ranges undo] {
   if $flag {
    if {[$E index $KO+1c] != $A} { 
     lappend UndoArray($E) "delete $KA $KO"
     set KA $A
    } 
   } {
    set flag 1
    set KA $A
   }
   set KO $O 
  }
  lappend UndoArray($E) "delete $KA $KO"
  $E tag remove undo 1.0 end
 }
}
proc switch_Undo {E Mode} {
 global UndoArray max_undo
 set sp 0
 switch $Mode UndoBeginSel {
  if {[$E tag nextrange sel 1.0 end] != ""} then {
   insert_undo $E
   lappend UndoArray($E) "insert [$E index sel.first] [backslash [$E get sel.first sel.last]]"
   set sp 1 
  }
  $E mark set UndoBegin insert
  $E mark gravity UndoBegin left
 } UndoBegin {
  if {[$E tag nextrange undo 1.0 end] != ""} then {
   set ksp 0
   foreach {A O} [$E tag ranges undo] {
    incr ksp
    lappend UndoArray($E) "delete $A $O" 
   }
   if {$ksp > 1} then {UndoMul $E $ksp}
   $E tag remove undo 1.0 end
  }
  $E mark set UndoBegin insert
  $E mark gravity UndoBegin left
 } UndoEnd {
  $E tag add undo UndoBegin insert
 } BeginMark {
  $E tag add undo BeginMark-1c BeginMark
 }
}
proc UndoMul {E Anz} {
 global UndoArray
 lappend UndoArray($E) "UndoMul $Anz"
}
proc switch_undo {E Mode} {
 global UndoArray max_undo BlockEditor

 insert_undo $E
 set sp 1
 switch $Mode sel {
  if {[$E tag nextrange sel 1.0 end] != ""} then {
   lappend UndoArray($E) "insert [$E index sel.first] [backslash [$E get sel.first sel.last]]" 
   set sp 0
  }
 } Delete {
  set sp [switch_undo $E sel]
  if $sp then {
   set ksp ""
   if {[lindex $UndoArray($E) end] != ""} then {
    if {[lindex [lindex $UndoArray($E) end] 0] == "insert"} then {
     if {[lindex [lindex $UndoArray($E) end] 1] == [$E index insert]} then {
      set ksp [lindex [lindex $UndoArray($E) end] 2]
      set UndoArray($E) [lrange $UndoArray($E) 0 [expr [llength $UndoArray($E)] - 2]]
     }
    }
   }
   lappend UndoArray($E) "insert [$E index insert] [backslash $ksp][backslash [$E get insert]]"
  }
 } BackSpace {
  set sp [switch_undo $E sel]
  if $sp then {
   set ksp ""
   if {[lindex $UndoArray($E) end] != ""} then {
    if {[lindex [lindex $UndoArray($E) end] 0] == "insert"} then {
     if {[lindex [lindex $UndoArray($E) end] 1] == [$E index insert]} then {
      set ksp [lindex [lindex $UndoArray($E) end] 2]
      set UndoArray($E) [lrange $UndoArray($E) 0 [expr [llength $UndoArray($E)] - 2]]
     }
    }
   }
   lappend UndoArray($E) "insert [$E index insert-1c] [backslash [$E get insert-1c]][backslash $ksp]" 
  }
 } Zeile {
  lappend UndoArray($E) "insert [$E index "insert linestart"] [backslash [$E get "insert linestart" "insert lineend + 1 chars"]]" 
 } Block {
   lappend UndoArray($BlockEditor) "insert [$BlockEditor index BlockBegin] [backslash [$BlockEditor get BlockBegin BlockEnd]]"
 } ErgDel {
  lappend UndoArray($E) "insert [$E index "insert - 1 chars wordstart - 1 chars"] [backslash [$E get "insert - 1 chars wordstart - 1 chars" insert]]"
 }
 while {[string length $UndoArray($E)] > $max_undo} {
  if {[llength $UndoArray($E)] != 0} then {
   set UndoArray($E) [lrange $UndoArray($E) 1 end]
  } else break
 }
 return $sp
}
################################################################
# Options
proc SaveOptions {} {
 global wsearch_gb KlammerFlag Package inifile myown Tcltexed_Version
 set f [open $inifile w]
 #Get text to save
 lappend liste $Tcltexed_Version $wsearch_gb $KlammerFlag "[array get Package]" "[array get myown]"
 #Save it
 puts $f $liste
 #and close file
 close $f
}
proc LoadOptions {} {
 global wsearch_gb KlammerFlag Package PLISTE bhtpath I_flag inifile myown Tcltexed_Version
 set default 1
 if [file exists $inifile] then {
  set f [open $inifile r]
  #Get text to save
  set liste [gets $f]
  if {[lindex $liste 0] == $Tcltexed_Version} {
   set wsearch_gb [lindex $liste 1]
   set KlammerFlag [lindex $liste 2]
   array set Package [lindex $liste 3]
   array set myown [lindex $liste 4]
   set default 0
  } else {
   set default 1
  }
  close $f
 } 
 if $default {
  foreach {i n} $PLISTE {
   set Package($i) 0
  }
  set Package(latex) 1
 }
 foreach {i n} $PLISTE {
  if $Package($i) then {
   set I_flag 1
   source $bhtpath/$i.bht
  }
 }
}
LoadOptions

####################################################################
proc InitMyOwn {} {
 global FocusEditorFlag FocusEditor myown myown_max
 if ![winfo exists .wmyown] then {
  toplevel .wmyown
  Cframe .wmyown
  wm title .wmyown "my own"
  for {set i 0} {$i < $myown_max} {incr i} {
   frame .wmyown.f$i
   Cframe .wmyown.f$i
   entry .wmyown.f$i.text -width 20 -relief sunken -textvariable myown($i)
   Ctext .wmyown.f$i.text
   button .wmyown.f$i.but  -command "if \$FocusEditorFlag {focus \$FocusEditor.te.edit1\n switch_Undo \$FocusEditor.te.edit1 UndoBegin\n \$FocusEditor.te.edit1 insert insert \[.wmyown.f$i.text get\]\n switch_Undo \$FocusEditor.te.edit1 UndoEnd\nswitch_undo \$FocusEditor.te.edit1 insert\n event generate \$FocusEditor.te.edit1 <<Position_tail>> -when tail}"
   Cbutton .wmyown.f$i.but
   menu .wmyown.f$i.pop_menu 
 .wmyown.f$i.pop_menu add command -label "Cut" -command "event generate .wmyown.f$i.text <<Cut>>"
 .wmyown.f$i.pop_menu add command -label "Copy" -command "event generate .wmyown.f$i.text <<Copy>>"
 .wmyown.f$i.pop_menu add command -label "Paste" -command "event generate .wmyown.f$i.text <<Paste>>" 
 .wmyown.f$i.pop_menu add command -label "Clear" -command "event generate .wmyown.f$i.text <<Clear>>" 
 bind .wmyown.f$i.text <Button-3> "tk_popup .wmyown.f$i.pop_menu \[winfo pointerx .wmyown.f$i\] \[winfo pointery .wmyown.f$i\]"


   pack  .wmyown.f$i.but .wmyown.f$i.text -side left
   pack .wmyown.f$i
  }
  button .wmyown.butQ -text "Quit" -command {
   destroy .wmyown
  }
  Cbutton .wmyown.butQ
  pack .wmyown.butQ
  wm minsize . 1 1
  bind .wmyown <<Help>> {Help tcltexed_hlp "My"}
  bind .wmyown <Control-c> {
   destroy .wmyown
 }}
 wm resizable .wmyown 0 0
}
#######################################################
# Farbige Syntax
proc Syntax E {
 global I_befehl
 $E tag remove syntax_green 1.0 end
 $E tag remove syntax_red 1.0 end
 $E tag remove syntax_blue 1.0 end
 set NEW_syntax [$E search "\\" 1.0 end]
 set LISTE [array names I_befehl]
 while {$NEW_syntax != ""} {
  $E mark set syntax $NEW_syntax
  set ksp [lsearch -exact $LISTE [$E get syntax+1c {syntax + 1 chars wordend}]]
  if {$ksp == -1} {
   $E tag add syntax_red syntax {syntax + 1 chars wordend}
  } else {
   $E tag add syntax_green syntax {syntax + 1 chars wordend}
  }
  set NEW_syntax [$E search "\\" syntax+1c end]
 }
 set NEW_syntax [$E search "%" 1.0 end]
 while {$NEW_syntax != ""} {
  $E mark set syntax $NEW_syntax
  $E tag add syntax_blue syntax {syntax lineend}
  set NEW_syntax [$E search "%" syntax+1c end]
 }

}
######################################################
# Bei Programstart eine Message
Help readme_hlp Tcltexed
